%{
/* sdl2c.y                                        bielefeld, den 8.4.1994
	Projekt sdl2c
	von sven goethel
*/

# include  "sdl2c.h"

/* DEFINES DEFINITIONEN */

/* laufvariable */
int i;

/* FLAGS */
int process_started=0;
int lokale_variable=0;
int decision_main;

/* decision level */
int decision_level=0;

/* INPUT flag, if an input if then else, is allready created */
int input_flag=0;

/* priority flag */
int prio=0;

YYSTYPE yylval;  /* yy_scan sets this ..... allready extern declared */

%}

%token  TPROCESS TENDPROCESS TENDPROCEDURE
%token  TPROCEDURE  TREFERENCED TCALL TPROVIDED
%token  TSTART TSTATE TENDSTATE TINPUT TSAVE TTASK
%token  TNEXTSTATE TJOIN TSTOP TRETURN TOUTPUT TCREATE
%token  TDECISION TELSE TENDDECISION
%token  TSEMI_COLON TCOLON TCOMMA TBRACE_OPEN TBRACE_CLOSE
%token  TTO TVIA TFROM
%token  <string> TRULE_NAME
%token  <string> TBRACE_SUBJECT TC_TEXT TPARAMETER_SUBJECT
%token  TFPAR TIN TIN_OUT
%token  TDCL TMACRO TMACRODEFINITION TENDMACRO

%type   <string> signal_list signal output_para_opt signal_origin_opt
%%

inhalt  : elements
	| inhalt elements
	;

elements : process
	 | procedure
	 | macro
	 | declaration
	 |  error {
		   scan->yyerror("elements incorrect");
	   }
	;

declarations_opt:
		| declarations
		;

declarations    : declaration
		| declarations declaration
		;

declaration     : TDCL 
		  { 
		    PRINT(".dcl start."); 
		    if(lokale_variable==0)
		      fprintf(fHeader,"SDL_TYPE"); 
		    else {
		      scan->space();
		      fprintf(scan->yyout,"SDL_TYPE"); 
		    }   
		  }
		  dcl_var
		  dcl_type_opt
		  TSEMI_COLON 
		  { 
		    if(lokale_variable==0)
		      fprintf(fHeader,";\n"); 
		    else fprintf(scan->yyout,";\n");
		    PRINT(".dcl end."); 
		  }
		| process_ref
		| procedure_ref
		| macro_ref
		;

dcl_var         : TRULE_NAME 
		  { 
		    if(lokale_variable==0)
		      fprintf(fHeader," %s", $1); 
		    else fprintf(scan->yyout," %s", $1);
		  }
		| dcl_var TCOMMA TRULE_NAME
		  { 
		    if(lokale_variable==0)
		      fprintf(fHeader,", %s", $3); 
		    else fprintf(scan->yyout,", %s", $3);
		  }
		;

dcl_type_opt    :
		| dcl_type
		;

dcl_type        : TRULE_NAME
		  { 
		    if(lokale_variable==0)
		      fprintf(fHeader," /* %s */", $1); 
		    else fprintf(scan->yyout," /* %s */", $1);
		  }
		;

process : TPROCESS TRULE_NAME
	  simple_end
	  {
	    fprintf(fHeader,"void %s ( ", $2);
	    scan->space();
	    fprintf(scan->yyout,"void %s ( ", $2);
	  }
	  parameter_opt
	  {
	    process_started=1;
	    fprintf(fHeader," ); /* PROCESS */ \n");
	    fprintf(scan->yyout," ) /* PROCESS */\n{\n\n");
	    scan->insert_level++;
	    PrintDef();
	    lokale_variable=1;
	  }
	  declarations_opt
	  {
	    lokale_variable=0;
	    input_flag=0;
	  }

	   process_body
	   TENDPROCESS
	   {
	     if(input_flag!=0) 
	     {
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* SWITCH(STATE) */ \n");
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* forever STATE */ \n");
	     }
	     scan->insert_level--;
	     scan->space();
	     fprintf(scan->yyout,"} /* ENDPROCESS */ \n");
	     PRINT(".process ende erkannt."); 
	   }
	   process_name_opt 
	   simple_end 
	;

process_ref     : TPROCESS TRULE_NAME TREFERENCED TSEMI_COLON
		;

procedure
	:   TPROCEDURE TRULE_NAME 
	    simple_end
	    {
	      fprintf(fHeader,"void %s ( ", $2);
	      scan->space();
	      fprintf(scan->yyout,"void %s ( ", $2);
	    }
	    parameter_opt
	  {
	    process_started=1;
	    fprintf(fHeader," ); /* PROCEDURE */ \n");
	    fprintf(scan->yyout," ) /* PROCEDURE */\n{\n\n");
	    lokale_variable=1;
	    scan->insert_level++;
	    PrintDef();
	  }
	  declarations_opt
	  {
	    lokale_variable=0;
	    input_flag=0;
	  }

	    process_body
	    TENDPROCEDURE { 
	     if(input_flag!=0) 
	     {
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* SWITCH(STATE) */ \n");
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* forever STATE */ \n");
	     }
	     scan->insert_level--;
	     scan->space();
	     fprintf(scan->yyout,"} /* ENDPROCEDURE */ \n");
	    }
	    procedure_name_opt
	    simple_end
	;

procedure_ref           : TPROCEDURE TRULE_NAME TREFERENCED TSEMI_COLON
			;

macro
	:   TMACRODEFINITION TRULE_NAME 
	    simple_end
	    {
	      fprintf(fHeader,"void %s ( ", $2);
	      scan->space();
	      fprintf(scan->yyout,"void %s ( ", $2);
	    }
	    parameter_opt
	  {
	    process_started=1;
	    fprintf(fHeader," ); /* MACRO */ \n");
	    fprintf(scan->yyout," ) /* MACRO */\n{\n\n");
	    scan->insert_level++;
	    lokale_variable=1;
	    PrintDef();
	  }
	  declarations_opt
	  {
	    lokale_variable=0;
	    input_flag=0;
	  }
	    process_body
	    TENDMACRO { 
	     if(input_flag!=0) 
	     {
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* SWITCH(STATE) */ \n");
	       scan->insert_level--;
	       scan->space();
	       fprintf(scan->yyout,"} /* forever STATE */ \n");
	     }
	     scan->insert_level--;
	     scan->space();
	     fprintf(scan->yyout,"} /* ENDMACRO */ \n");
	    }
	    macro_name_opt
	    simple_end
	;

macro_ref       : TMACRODEFINITION TRULE_NAME TREFERENCED TSEMI_COLON 
		;

parameter_opt   : /* empty */
		| parameter 
		  { 
		    fprintf(scan->yyout,"%s", YBuffer);
		    fprintf(fHeader,"%s", YBuffer);
		  }
		;

parameter       : TFPAR
		  in_out_opt
		  paras
		;

paras           : TPARAMETER_SUBJECT 
		  { 
		    strcpy(YBuffer,"SDL_TYPE ");
		    strcat(YBuffer, $1); 
		  }
		| paras TPARAMETER_SUBJECT
		  {
		    strcat(YBuffer,", SDL_TYPE ");
		    strcat(YBuffer, $2); 
		  }
		;

in_out_opt      : 
		| TIN 
		| TIN_OUT
		;

process_body
	:   start_opt  
	    transition
	    state_bodys_opt
	;

start_opt       : /* empty */
		| TSTART
		  simple_end
		;

transition
	:   transition_string
	|   transition_string terminator_statement
	|   terminator_statement
	|   error {
		  scan->yyerror("transition incorrect");
	    }
	;


state_bodys_opt : 
		| state_bodys
		;

state_bodys     : state_body
		| state_bodys state_body
		;

state_body
	:   TSTATE 
	    TRULE_NAME 
	    { 
	      for(i=0; $2[i]!=0; i++)
		$2[i]=toupper($2[i]);
	      if(process_started)
	      {
		fprintf(scan->yyout,"__STATE_LOOP__:\n");
		scan->space();
		fprintf(scan->yyout,"for(;;) /* forever STATE */\n");
		scan->space();
		fprintf(scan->yyout,"{\n");
		scan->insert_level++;
		scan->space();
		fprintf(scan->yyout,"switch(state) /* STATE */ \n");
		scan->space();
		fprintf(scan->yyout,"{\n");
		scan->insert_level++;
		process_started=0;
	      }
	      scan->space();
	      fprintf(scan->yyout,"case %s :\n", $2);
	      scan->insert_level++;
	      scan->space();
	      fprintf(scan->yyout,"Wait4Signal(&sr);\n");
	      fprintf(fStates,"%s\n", $2);
	      input_flag=0;
	    }
	    simple_end
	    { PRINT(".STATE rec."); }
	    state_recur
	    { PRINT(".STATE recur end."); }
	    endstate_opt 
	    { 
	      scan->insert_level--;
	      scan->space();
	      fprintf(scan->yyout,"} /* IF SIGNAL END */\n");
	      scan->insert_level--;
	      PRINT(".STATE END."); 
	    }
	;

	state_recur
		:   state_input_contiguous_save
		|   state_recur state_input_contiguous_save
		;

	state_input_contiguous_save
	:  state_input
	   enabling_condition_opt
	   transition
	|  contiguous_signal
	   transition
	|  state_save
	;


	state_input
		:   TINPUT TRULE_NAME signal_origin_opt simple_end
		    { 
		      PRINT(".INPUT rec.");
		      for(i=0; $2[i]!=0; i++)
			$2[i]=toupper($2[i]);
		      fprintf(fSignals,"%s\n", $2);
		      if(input_flag!=0)
		      {
			scan->insert_level--;
			scan->space();
			fprintf(scan->yyout,"} else ");
		      } else scan->space();
		      fprintf(scan->yyout,"if ( sr.Signal == %s && sr.OriginProcess == ", $2 );
		      if(strcmp($3,"")==0) fprintf(scan->yyout,"MYSELF )\n");
		      else fprintf(scan->yyout,"%s )\n", $3);
		      scan->space();
		      fprintf(scan->yyout,"{\n");
		      scan->insert_level++;
		      if(prio)
		      {
			scan->space();
			fprintf(scan->yyout,"/* PRIORITY INPUT !!! */\n");
		      }
		      input_flag=1;
		      prio=0;
		      PRINT(".state input ok.");
		    }
		;

	signal_origin_opt       : { $$=strdup(""); }
				| TFROM TC_TEXT
				  { 
				    for(i=0; $2[i]!=0; i++)
				      $2[i]=toupper($2[i]);
				    fprintf(fProcess,"%s\n", $2);
				    $$=strdup(YBuffer);
				  }
				;

	enabling_condition_opt
	:   /* leer */
		|   TPROVIDED 
			 { NotSupportedYet(); }
		    simple_end
		;

	contiguous_signal
		:   TPROVIDED 
		    { scan->insert_level++; NotSupportedYet(); }
		    simple_end
		;

	state_save
	:   TSAVE 
	    { scan->insert_level++; NotSupportedYet(); }
	    simple_end
	;

	endstate_opt
		:   /*   leer   */
		|   TENDSTATE 
		    state_name_opt
		    simple_end
		;

	/**********************************************************************/

transition_string
	:   transition_string_recur
	|   terminator_statement 
	    { PRINT(".transition string(terminator statement found)."); }
	    label 
	|   transition_string transition_string_recur
	;

	/**********************************************************************/

	transition_string_recur
		 :  n_action 
		    end 
		 ;

	/**********************************************************************/

n_action        : /* empty */
		| action
		| label action 
		;

label            : TRULE_NAME 
		   TCOLON
		   { 
		     fprintf(scan->yyout,"_%s :\n", $1);
		     PRINT(".label.");
		   }
		 ;

action  :   task               { PRINT(".task ok."); }  
	|   output             { PRINT(".output ok."); }
	|   create_request     { PRINT(".create ok."); }
	|   decision           { PRINT(".decision ok."); }
	|   procedure_call     { PRINT(".procedure call ok."); }
	|   macro_call         { PRINT(".macro call ok."); }
	;

procedure_call
	:   TCALL 
	    c_txt_end
	;

macro_call
	:   TMACRO 
	    c_txt_end
	;

task    :
	  TTASK 
	  c_txt_end
	;

c_txt_end :  TC_TEXT
	     {
	       scan->space();
	       fprintf(scan->yyout,"%s ;\n", $1);
	     }
	  ;

terminator_statement
	:   terminator
	    simple_end
	    { PRINT(".terminator_statement."); }
	;

	/**********************************************************************/

terminator
	:   TNEXTSTATE TRULE_NAME 
	    {
	      scan->space();
	      for(i=0; $2[i]!=0; i++)
		$2[i]=toupper($2[i]);
	      fprintf(scan->yyout,"state = %s;\n", $2);
	      scan->space();
	      fprintf(scan->yyout,"goto __STATE_LOOP__;\n");
	    }
	|   TJOIN TRULE_NAME 
	    { 
	      scan->space();
	      fprintf(scan->yyout,"goto _%s;\n", $2);
	    }
	|   TSTOP {
	      scan->space();
	      fprintf(scan->yyout,"StopProcess();\n");
	   }
	|   TRETURN {
	      scan->space();
	      fprintf(scan->yyout,"return();\n");
	   }
	;

output   :  TOUTPUT
	    signal_list
	    TTO TC_TEXT
	    {
	      if(prio)
	      {
		scan->space();
		fprintf(scan->yyout,"/* PRIORITY OUTPUT !!! */\n");
	      }
	      for(i=0; $4[i]!=0; i++)
		$4[i]=toupper($4[i]);
	      scan->space();
	      fprintf(scan->yyout,"SendTo (%s, %s) ;\n", $4, $2);
	      fprintf(fProcess,"%s\n", $4);
	      prio=0;
	    }
	 |  TOUTPUT
	    signal_list
	    TVIA TC_TEXT
	    {
	      if(prio)
	      {
		scan->space();
		fprintf(scan->yyout,"/* PRIORITY OUTPUT !!! */\n");
	      }
	      for(i=0; $4[i]!=0; i++)
		$4[i]=toupper($4[i]);
	      scan->space();
	      fprintf(scan->yyout,"SendVia (%s, %s) ;\n", $4, $2);
	      fprintf(fProcess,"%s\n", $4);
	      prio=0;
	    }
	 ;

signal_list     : signal
		  { $$=$1; }
		| signal_list TCOMMA signal
		  {
		    sprintf(YBuffer,"%s, %s", $1, $3);
		    $$=strdup(YBuffer);
		  }
		;

signal          : TRULE_NAME
		  output_para_opt
		  {
		    for(i=0; $1[i]!=0; i++)
		      $1[i]=toupper($1[i]);
		    sprintf(YBuffer,"%s%s", $1, $2);
		    fprintf(fSignals,"%s\n", $1);
		    $$=strdup(YBuffer);
		  }
		;

output_para_opt: /* empty */ { $$=strdup(""); }
	       | TBRACE_OPEN
		 TBRACE_SUBJECT
		 TBRACE_CLOSE
		 {
		   for(i=0; $2[i]!=0; i++)
		     $2[i]=toupper($2[i]);
		   sprintf(YBuffer," ( %s )", $2);
		   $$=strdup(YBuffer);
		 }
	       ;

end     : simple_end
	;

create_request
	:   TCREATE 
			 { NotSupportedYet(); }
	;

decision
	:   TDECISION 
	    TC_TEXT
	    { 
	      decision_level++;
	      scan->space();
	      fprintf(scan->yyout,"__decision[%d] = ( %s );\n", decision_level, $2);
	      decision_main=1; 
	      PRINT(".DECISION QUESTION.");
	      /* einruecken fuer den if-befehl, */
	      /* der mit answer generiert wird. */
	      scan->space();
	    }
	    simple_end
	    decision_answer_else
	TENDDECISION {
		scan->insert_level--;
		scan->space();
		fprintf(scan->yyout,"}\n");
		decision_level--;
		PRINT(".DECISION CASE END.");
	    }
	;


	/**********************************************************************/

	decision_answer_else
		:   decision_answer_recur
		|   decision_answer_recur decision_else
		|   decision_else
		;

	decision_answer_recur
		:   decision_answer
		|   decision_answer_recur decision_answer
		;

	decision_answer
		:   answer 
		    TCOLON 
		    transition
		;

	decision_else
		:   TELSE {
			scan->insert_level--;
			scan->space();
			fprintf(scan->yyout,"} else {\n");
			scan->insert_level++;
		    }
		    TCOLON  
		    transition
		;

	/**********************************************************************/


answer  :
	    TBRACE_OPEN   
	    TBRACE_SUBJECT
	    TBRACE_CLOSE
	    {
	      if(decision_main==0)
	      {
		scan->insert_level--;
		scan->space();
		fprintf(scan->yyout,"} else ");
	      } else {
		decision_main=0;        
	      }
	      fprintf(scan->yyout,"if ( __decision[%d] %s )\n", decision_level, $2);
	      scan->space();
	      fprintf(scan->yyout,"{\n");
	      scan->insert_level++;
	      PRINT(".DECISION ANSWER DONE.");
	    }
	;

/**********   name  rules    **************************************************/

	process_name_opt
		:   name_opt
		;

	procedure_name_opt
		:   name_opt
		;

	state_name_opt
		:   name_opt
		;
	macro_name_opt  
		:   name_opt
		;


name_opt
	:   /*   leer   */
	| name
	;

name    : TRULE_NAME 
	;

simple_end      : TSEMI_COLON  
		;

/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
/***************************************************************************/
%%
