%{
/* sdl2c.lex                                      bielefeld, den 8.4.1994
   Projekt sdl2c
   von sven goethel
*/

# include "sdl2c.h"

%}

%p 3000
%a 2000
%o 2000

%s NORMAL CMNT BRACE_SUBJECT C_TEXT PARAS

%%

%{
  if(first_time) {
	LBuffer[0]=0;
	BEGIN NORMAL;
	first_time=0;
  }
%}

<NORMAL>" "             { ; }
<NORMAL>\t              { ; }
<NORMAL>\n              { ; }

<NORMAL>PROCESS         { return  TPROCESS; }
<NORMAL>ENDPROCESS      { return  TENDPROCESS; }
<NORMAL>PROCEDURE       { return  TPROCEDURE; }
<NORMAL>ENDPROCEDURE    { return  TENDPROCEDURE; }
<NORMAL>MACRO           { BEGIN C_TEXT; return  TMACRO; }
<NORMAL>MACRODEFINITION { return  TMACRODEFINITION; }
<NORMAL>ENDMACRO        { return  TENDMACRO; }
<NORMAL>DCL             { return  TDCL; }
<NORMAL>REFERENCED      { return  TREFERENCED; }
<NORMAL>CALL            { BEGIN C_TEXT; return  TCALL; }
<NORMAL>PROVIDED        { return  TPROVIDED; }
<NORMAL>START           { return  TSTART; }
<NORMAL>STATE           { return  TSTATE; }
<NORMAL>ENDSTATE        { return  TENDSTATE; }
<NORMAL>INPUT           { return  TINPUT; }
<NORMAL>SAVE            { return  TSAVE; }
<NORMAL>TASK            { BEGIN C_TEXT; return  TTASK; }
<NORMAL>NEXTSTATE       { return  TNEXTSTATE; }
<NORMAL>JOIN            { return  TJOIN; }
<NORMAL>STOP            { return  TSTOP; }
<NORMAL>RETURN          { return  TRETURN; }
<NORMAL>OUTPUT          { return  TOUTPUT; }
<NORMAL>CREATE          { return  TCREATE; }
<NORMAL>DECISION        { BEGIN C_TEXT; return  TDECISION; }
<NORMAL>ELSE            { return  TELSE; }
<NORMAL>ENDDECISION     { return  TENDDECISION; }
<NORMAL>TO|to           { BEGIN C_TEXT; return  TTO; }
<NORMAL>VIA|via         { BEGIN C_TEXT; return  TVIA; }
<NORMAL>FROM|from       { BEGIN C_TEXT; return  TFROM; }
<NORMAL>PRIORITY	{ prio=1; }

<NORMAL>";"             { return  TSEMI_COLON; }
<NORMAL>":"             { return  TCOLON; }
<NORMAL>","             { return  TCOMMA; }

<NORMAL>FPAR            { BEGIN PARAS; LBuffer[0]=0; return  TFPAR; }
<PARAS>\,               {
			  yylval.string=strdup(LBuffer);
			  LBuffer[0]=0;
			  return TPARAMETER_SUBJECT;
			}
<PARAS>\;               {
			  BEGIN NORMAL;
			  yylval.string=strdup(LBuffer);
			  LBuffer[0]=0;
			  return TPARAMETER_SUBJECT;
			}
<PARAS>.|\n             { strcat (LBuffer,yytext); }

<PARAS>IN               { return  TIN; }
<PARAS>IN/OUT           { return  TIN_OUT; }

<NORMAL>"/*"            {
			  BEGIN CMNT;
			  strcpy(LBuffer,yytext);
			}
<CMNT>.|\n              { strcat(LBuffer,yytext); }
<CMNT>"*/"              {
			  BEGIN NORMAL;
			  space();
			  fprintf(yyout,"%s*/\n", LBuffer);
			  LBuffer[0]=0;
			}

<NORMAL>"("                         {
				      BEGIN BRACE_SUBJECT;
				      return  TBRACE_OPEN;
				    }
<NORMAL>")"                         { return  TBRACE_CLOSE; }
<BRACE_SUBJECT>"/="                 { strcat(LBuffer,((string==0)?"!=":yytext)); }
<BRACE_SUBJECT>":="                 { strcat(LBuffer,((string==0)?"=":yytext)); }
<BRACE_SUBJECT>"="                  { strcat(LBuffer,((string==0)?"==":yytext)); }
<BRACE_SUBJECT>"NOT"                { strcat(LBuffer,((string==0)?"!":yytext)); }
<BRACE_SUBJECT>"MOD"                { strcat(LBuffer,((string==0)?"%":yytext)); }
<BRACE_SUBJECT>"AND"                { strcat(LBuffer,((string==0)?"&&":yytext)); }
<BRACE_SUBJECT>"OR"                 { strcat(LBuffer,((string==0)?"||":yytext)); }
<BRACE_SUBJECT>"XOR"                { strcat(LBuffer,((string==0)?"^":yytext)); }
<BRACE_SUBJECT>"true"               { strcat(LBuffer,((string==0)?" == 1":yytext)); }
<BRACE_SUBJECT>")"                  {
				      unput(')'); 
				      yylval.string=strdup(LBuffer); 
				      LBuffer[0]=0;
				      string=0;
				      BEGIN NORMAL;
				      return  TBRACE_SUBJECT; 
				    }
<BRACE_SUBJECT>.|\n                 { 
					  if(strcmp(yytext,"'")==0)
				      {
					if(string) string=0;
					else string=1;
				      }
					  strcat(LBuffer,yytext);
				    }

<C_TEXT>"/="                { char_exist=1; strcat(LBuffer,((string==0)?"!=":yytext)); }
<C_TEXT>":="                { char_exist=1; strcat(LBuffer,((string==0)?"=":yytext)); }
<C_TEXT>"="                 { char_exist=1; strcat(LBuffer,((string==0)?"==":yytext)); }
<C_TEXT>"NOT"               { char_exist=1; strcat(LBuffer,((string==0)?"!":yytext)); }
<C_TEXT>"MOD"               { char_exist=1; strcat(LBuffer,((string==0)?"%":yytext)); }
<C_TEXT>"AND"               { char_exist=1; strcat(LBuffer,((string==0)?"&&":yytext)); }
<C_TEXT>"OR"                { char_exist=1; strcat(LBuffer,((string==0)?"||":yytext)); }
<C_TEXT>"XOR"               { char_exist=1; strcat(LBuffer,((string==0)?"^":yytext)); }
<C_TEXT>";"                 { 
			      unput(';'); 
			      yylval.string=strdup(LBuffer); 
			      LBuffer[0]=0;
			      char_exist=0;
			      string=0;
			      BEGIN NORMAL;
			      return  TC_TEXT; 
			    }

<C_TEXT>" "|\t              {
			      if(char_exist)
			      {
				strcat(LBuffer,yytext);
			      }
			    }

<C_TEXT>.|\n                { 
				  if(strcmp(yytext,"'")==0)
			      {
				if(string) string=0;
				else string=1;
			      }
				  strcat(LBuffer, yytext);
				  char_exist=1;
			    }


<NORMAL>([0-9]|[a-zA-Z]|".")+([a-zA-Z]|[0-9]|"."|"_")*  { 
				  yylval.string=strdup(yytext);
				  return  TRULE_NAME; 
				}

<NORMAL>.|\n            { printf("%s", yytext); }

%%






